#ifndef __Network_H__
#define __Network_H__

#include "Layer.h"

#include <string>

class Network
{
public:
	Layer *layers;
	int layerCount;

	double learningRate;	

	~Network()
	{
		delete[] layers;
	}

	Layer* outputLayer()
	{
		return layers + layerCount - 1;
	}

	Layer* inputLayer()
	{
		return layers;
	}

	void init(int layerCount = 0, int *layerNeuronCount = NULL, double learningRate = 0);
	void setInputLayer(double *in);
	double* getOutputLayer();
	void run();
	void train(double *answer);
	void save(std::string filename);
	bool load(std::string filename);
	void saveGraph(std::string filename);
};

#endif /* __Network_H__ */

